$(function ($) {
    var timeToSet = '{{ timeToSet|date("H:i") }}';
    var setTimeModal = $("#setTime");
    var timeToSetInput = $('#timeToSet');
    var setTimeConfirmBt = $("#setTimeConfirm");
    var permitPersonalDeviceInput = $('#permitPersonalDevice');
    var permitPersonalDeviceMsg = $('#permitPersonalDeviceMsg');
    var activatedPollingUrl = "{% if activatedUser != "" %}{{ path('internetIsOnForUser',{'providerId': provider.id, 'groupId': group.id, 'studentId': activatedUser }) }}{% endif %}";
    var activatedPoolingRetryTimes = 0;

    $(".internetOn").click(function () {
        setTimeModal.modal('show');
        setTimeConfirmBt.data("studentId", $(this).attr("id").substring(11));
        $('#setTimeUser').html($(this).parent().parent().data('student-name'));
    });

    setTimeModal.on("shown.bs.modal", function (e) {
        timeToSetInput.focus();
    });

    timeToSetInput.on("keydown", function (e) {
        if (e.which === 13) {
            e.preventDefault();
            setTimeConfirmBt.click();
        } else if (e.which === 32) {
            e.preventDefault();
            permitPersonalDeviceInput.click();
        }
    });

    permitPersonalDeviceInput.on("keydown", function (e) {
        if (e.which === 13) {
            e.preventDefault();
            setTimeConfirmBt.click();
        }
    });

    setTimeConfirmBt.click(function () {
        if (timeToSetInput.val() !== "")
            timeToSet = timeToSetInput.val();

        var path = "{{ path('internetOnUser',{'providerId': provider is defined ? provider.id : '0', 'groupId': group is defined ? group.id : '0', 'studentId': '%studentId'}) }}?".replace("%25studentId", $(this).data("studentId"));
        window.location.href = path + "timeToSet=" + timeToSet + "&personalDevice=" + (permitPersonalDeviceInput.is(':checked') ? "1" : "0");
        setTimeModal.modal('hide');
    });


    permitPersonalDeviceInput.click(function () {
        if (permitPersonalDeviceInput.is(':checked')) {
            permitPersonalDeviceMsg.show();
        } else {
            permitPersonalDeviceMsg.hide();
        }
    });

    var activatedPolling = function () {
        $.get(activatedPollingUrl, function (data) {
            if (data.error === undefined && data.on === true && data.activationCompleted === true) {
                window.location.reload();
            }

            if (++activatedPoolingRetryTimes < 10) {
                setTimeout(activatedPolling, 1500);
            }
        });
    };

    if (activatedPollingUrl !== "") {
        setTimeout(activatedPolling, 1500);
    }

    $(document).ajaxError(function (event, jqXHR) {
        if (jqXHR.status === 403 && jqXHR.responseText === "Authentication timeout") {
            window.location.reload();
        }
    });

});
